import { CompanyActionTypes } from './company.action.types';
import { Action } from '@ngrx/store';
import { Company } from 'src/app/shared/models/company/company.model';
/** all actions related to company */

//get all companies
export class GetAllCompaniesAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES;
  constructor(public payload: any) {}
}

export class GetAllCompaniesActionSuccess implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_SUCCESS;
  constructor(public payload: Company[]) {}
}

export class GetAllCompaniesActionError implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_ALL_COMPANIES_ERROR;
  constructor(public payload: string) {}
}

//create form to create company
export class CreateCompanyFormAddAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.CREATE_COMPANY_FORM_ADD;
  constructor(public payload: void) {}
}

export class CreateCompanyFormAddActionSuccess implements Action {
  type: CompanyActionTypes = CompanyActionTypes.CREATE_COMPANY_FORM_ADD_SUCCESS;
  constructor(public payload: void) {}
}

export class CreateCompanyFormAddActionError implements Action {
  type: CompanyActionTypes = CompanyActionTypes.CREATE_COMPANY_FORM_ADD_ERROR;
  constructor(public payload: string) {}
}

// save company with form data
export class SaveCompanyFormDataAddAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.SAVE_COMPANY_FORM_DATA_ADD;
  constructor(public payload: Company) {}
}
export class SaveCompanyFormDataAddActionSuccess implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.SAVE_COMPANY_FORM_DATA_ADD_SUCCESS;
  constructor(public payload: Company) {}
}

export class SaveCompanyFormDataAddActionError implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.SAVE_COMPANY_FORM_DATA_ADD_ERROR;
  constructor(public payload: string) {}
}

//create form to update company
export class CreateFormToUpdateCompanyAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE;
  constructor(public payload: Company) {}
}

export class CreateFormToUpdateCompanyActionSuccess implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE_SUCCESS;
  constructor(public payload: Company) {}
}

export class CreateFormToUpdateCompanyActionError implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.CREATE_COMPANY_FORM_UPDATE_ERROR;
  constructor(public payload: string) {}
}

//save form data to update company
export class UpdateCompanyWithFormDataAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA;
  constructor(public payload: Company) {}
}

export class UpdateCompanyWithFormDataActionSuccess implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA_SUCCESS;
  constructor(public payload: Company) {}
}

export class UpdateCompanyWithFormDataActionError implements Action {
  type: CompanyActionTypes =
    CompanyActionTypes.UPDATE_COMPANY_WITH_FORM_DATA_ERROR;
  constructor(public payload: string) {}
}

// detele a company
export class DeleteCompanyAction implements Action {
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY;
  constructor(public payload: Company) {}
}

export class DeleteCompanyActionSuccess implements Action {
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_SUCCESS;
  constructor(public payload: Company) {}
}

export class DeleteCompanyActionError implements Action {
  type: CompanyActionTypes = CompanyActionTypes.DELETE_COMPANY_ERROR;
  constructor(public payload: string) {}
}

// Get company's projects
export class GetCompany_S_Projects implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_COMPANY_S_PROJECTS;
  constructor(public payload: any) {}
}

export class GetCompany_S_ProjectsSuccess implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_COMPANY_S_PROJECTS_SUCCESS;
  constructor(public payload: any) {}
}

export class GetCompany_S_ProjectsError implements Action {
  type: CompanyActionTypes = CompanyActionTypes.GET_COMPANY_S_PROJECTS_ERROR;
  constructor(public payload: string) {}
}


export type CompanyActionUnion =
  | GetAllCompaniesAction
  | GetAllCompaniesActionSuccess
  | GetAllCompaniesActionError
  | CreateCompanyFormAddAction
  | CreateCompanyFormAddActionSuccess
  | CreateCompanyFormAddActionError
  | SaveCompanyFormDataAddAction
  | SaveCompanyFormDataAddActionSuccess
  | SaveCompanyFormDataAddActionError
  | CreateFormToUpdateCompanyAction
  | CreateFormToUpdateCompanyActionSuccess
  | CreateFormToUpdateCompanyActionError
  | UpdateCompanyWithFormDataAction
  | UpdateCompanyWithFormDataActionSuccess
  | UpdateCompanyWithFormDataActionError
  | DeleteCompanyAction
  | DeleteCompanyActionSuccess
  | DeleteCompanyActionError
  | GetCompany_S_Projects
  | GetCompany_S_ProjectsSuccess
  | GetCompany_S_ProjectsError;
