import { Project } from './../../shared/models/project/project.model';
import { ProjectActionTypes } from './project.action.types';
import { Action } from '@ngrx/store';

/** create actions related to projects */

//create get all project action
export class GetAllProjectsAction implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS;
  constructor(public payload: any) {}
}

export class GetAllProjectsActionSuccess implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS_SUCCESS;
  constructor(public payload: Project[]) {}
}

export class GetAllProjectsActionError implements Action {
  type: ProjectActionTypes = ProjectActionTypes.GET_ALL_PROJECTS_ERROR;
  constructor(public payload: string) {}
}

//create project form to add a project

export class CreateProjectFormAddAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_ADD;
  constructor (public payload: any){}
}

export class CreateProjectFormAddActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_ADD_SUCCESS;
  constructor (public payload: any){}
}

export class CreateProjectFormAddActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_ADD_ERROR;
  constructor (public payload: string){}
}

//save project form data
export class SaveProjectFormDataAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.SAVE_PROJECT_FORM_DATA;
  constructor (public payload: Project){}
}
//save project form data
export class SaveProjectFormDataActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.SAVE_PROJECT_FORM_DATA_SUCCESS;
  constructor (public payload: Project){}
}
//save project form data
export class SaveProjectFormDataActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.SAVE_PROJECT_FORM_DATA_ERROR;
  constructor (public payload: string){}
}

//create form for project update
export class CreateProjectFormUpdateAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_UPDATE;
  constructor(public payload: Project){}
}

export class CreateProjectFormUpdateActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_UPDATE_SUCCESS;
  constructor(public payload: Project){}
}

export class CreateProjectFormUpdateActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.CREATE_PROJECT_FORM_UPDATE_ERROR;
  constructor(public payload: string){}
}

// update project with form data
export class UpdateProjectWithFormDataAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT_WITH_FORM_DATA;
  constructor (public payload: Project){}
}
export class UpdateProjectWithFormDataActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT_WITH_FORM_DATA_SUCCESS;
  constructor (public payload: Project){}
}
export class UpdateProjectWithFormDataActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.UPDATE_PROJECT_WITH_FORM_DATA_ERROR;
  constructor (public payload: string){}
}

// delete a project
export class DeleteProjectAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT;
  constructor(public payload: Project){}
}
export class DeleteProjectActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT_SUCCESS;
  constructor(public payload: Project){}
}
export class DeleteProjectActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.DELETE_PROJECT_ERROR;
  constructor(public payload: string){}
}

// get project with user associated
export class GetProjectWithUserAssociatedAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_USER_ASSOCIATED;
  constructor(public payload: any){}
}
export class GetProjectWithUserAssociatedActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_USER_ASSOCIATED_SUCCESS;
  constructor(public payload: any){}
}
export class GetProjectWithUserAssociatedActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_USER_ASSOCIATED_ERROR;
  constructor(public payload: string){}
}

// get project with company associated
export class GetProjectWithCompanyAssociatedAction implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_COMPANY_ASSOCIATED;
  constructor(public payload: any){}
}
export class GetProjectWithCompanyAssociatedActionSuccess implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_COMPANY_ASSOCIATED_SUCCESS;
  constructor(public payload: any){}
}
export class GetProjectWithCompanyAssociatedActionError implements Action{
  type: ProjectActionTypes = ProjectActionTypes.GET_PROJECT_WITH_COMPANY_ASSOCIATED_ERROR;
  constructor(public payload: string){}
}

export type ProjectActionUnion =
  | GetAllProjectsAction
  | GetAllProjectsActionSuccess
  | GetAllProjectsActionError
  | CreateProjectFormAddAction
  | CreateProjectFormAddActionSuccess
  | CreateProjectFormAddActionError
  | SaveProjectFormDataAction
  | SaveProjectFormDataActionSuccess
  | SaveProjectFormDataActionError
  | CreateProjectFormUpdateAction
  | CreateProjectFormUpdateActionSuccess
  | CreateProjectFormUpdateActionError
  | UpdateProjectWithFormDataAction
  | UpdateProjectWithFormDataActionSuccess
  | UpdateProjectWithFormDataActionError
  | DeleteProjectAction
  | DeleteProjectActionSuccess
  | DeleteProjectActionError
  | GetProjectWithUserAssociatedAction
  | GetProjectWithUserAssociatedActionSuccess
  | GetProjectWithUserAssociatedActionError
  | GetProjectWithCompanyAssociatedAction
  | GetProjectWithCompanyAssociatedActionSuccess
  | GetProjectWithCompanyAssociatedActionError;
