import { Router } from '@angular/router';
import { GetAllCompaniesAction } from './../../../../ngrx/companies/companies.actions';
import { CompanyState } from './../../../../ngrx/companies/company.state';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-company-nav-bar',
  templateUrl: './company-nav-bar.component.html',
  styleUrls: ['./company-nav-bar.component.css'],
})
export class CompanyNavBarComponent {
  constructor(
    private store: Store<{ companyReducerKey: CompanyState }>,
    private router: Router
  ) {}

  companyState!: CompanyState;

  onCompanyCreate() {
    this.router.navigateByUrl('/company-create');
  }

  onCompaniesGetAll() {
    this.store.dispatch(new GetAllCompaniesAction({}));
    this.store.subscribe((state) => {
      this.companyState = state.companyReducerKey;
    });
  }

  onCompany_s_Projects() {
    this.router.navigateByUrl('/company-s-projects');
  }
}
