import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { TableModule } from 'primeng/table';
import { ButtonModule } from 'primeng/button';
import { NgModule } from '@angular/core';
import { CommonModule, DatePipe } from '@angular/common';

import { CompaniesManagerRoutingModule } from './companies-manager-routing.module';
import { CompanyNavBarComponent } from './companies-management/company-nav-bar/company-nav-bar.component';
import { CompaniesManagementComponent } from './companies-management/companies-management.component';
import { CompaniesListComponent } from './companies-management/companies-list/companies-list.component';
import { CompanyUpdateComponent } from './companies-management/company-update/company-update.component';
import { CompanySProjectsComponent } from './companies-management/company-s-projects/company-s-projects.component';
import { CompanySProjectsListComponent } from './companies-management/company-s-projects/company-s-projects-list/company-s-projects-list.component';
import { CompanyCreateComponent } from './companies-management/company-create/company-create.component';


@NgModule({
  declarations: [
    CompanyNavBarComponent,
    CompaniesManagementComponent,
    CompaniesListComponent,
    CompanyUpdateComponent,
    CompanySProjectsComponent,
    CompanySProjectsListComponent,
    CompanyCreateComponent
  ],
  imports: [
    CommonModule,
    CompaniesManagerRoutingModule,
    ButtonModule,
    TableModule,
    ReactiveFormsModule,
    FormsModule
  ],
  providers:[DatePipe]
})
export class CompaniesManagerModule { }
