import { Router } from '@angular/router';
import {
  GetAllProjectsAction
} from './../../../../ngrx/projects/projects.actions';
import { Component } from '@angular/core';
import { Store } from '@ngrx/store';

@Component({
  selector: 'app-project-nav-bar',
  templateUrl: './project-nav-bar.component.html',
  styleUrls: ['./project-nav-bar.component.css'],
})
export class ProjectNavBarComponent {
  constructor(private store: Store<any>, private router: Router) {}

  onProjectCreate() {
    this.router.navigateByUrl('/project-create');
  }

  onProjectsGetAll() {
    this.store.dispatch(new GetAllProjectsAction({}));
  }

  onGetProjectWithUserAssociated() {
    this.router.navigate(['/project-user-asscociated'])
  }

  onGetProjectWithCompanyAssociated() {
    this.router.navigate(['/project-company-asscociated'])
  }
}
