import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';
import { MsgState } from 'src/app/ngrx/msg.state';
import { ProjectState } from 'src/app/ngrx/projects/project.state';
import { GetProjectWithUserAssociatedAction } from 'src/app/ngrx/projects/projects.actions';

@Component({
  selector: 'app-project-with-user-associated',
  templateUrl: './project-with-user-associated.component.html',
  styleUrls: ['./project-with-user-associated.component.css']
})
export class ProjectWithUserAssociatedComponent implements OnInit {


  projectState!: ProjectState;
  msgState = MsgState;
  constructor(private store:Store<{projectReducerKey: ProjectState}>) { }

  ngOnInit(): void {

    this.store.dispatch(new GetProjectWithUserAssociatedAction({}));
    this.store.subscribe(projectState => {
      this.projectState = projectState.projectReducerKey;
    })
  }


}
