import { Observable } from 'rxjs';
import { ProjectState } from './../../../ngrx/projects/project.state';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';
import { MsgState } from 'src/app/ngrx/msg.state';


@Component({
  selector: 'app-projects-management',
  templateUrl: './projects-management.component.html',
  styleUrls: ['./projects-management.component.css']
})
export class ProjectsManagementComponent implements OnInit {

  constructor(private store: Store<{projectReducerKey: ProjectState}>) { }

  projectState$!:Observable<ProjectState>

  readonly msgState = MsgState;

  ngOnInit(): void {

    this.projectState$= this.store.select("projectReducerKey");
  }

}
