import { TableModule } from 'primeng/table';
import { ButtonModule } from 'primeng/button';
import { NgModule } from '@angular/core';
import { CommonModule, DatePipe } from '@angular/common';

import { ProjectsManagerRoutingModule } from './projects-manager-routing.module';
import { ProjectCreateComponent } from './projects-management/project-create/project-create.component';
import { ProjectNavBarComponent } from './projects-management/project-nav-bar/project-nav-bar.component';
import { ProjectsManagementComponent } from './projects-management/projects-management.component';
import { ProjectsListComponent } from './projects-management/projects-list/projects-list.component';
import { ProjectUpdateComponent } from './projects-management/project-update/project-update.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { ProjectWithUserAssociatedComponent } from './projects-management/project-with-user-associated/project-with-user-associated.component';
import { ProjectWithUserAssociatedListComponent } from './projects-management/project-with-user-associated/project-with-user-associated-list/project-with-user-associated-list.component';
import { ProjectWithCompanyAssociatedComponent } from './projects-management/project-with-company-associated/project-with-company-associated.component';
import { ProjectWithCompanyAssociatedListComponent } from './projects-management/project-with-company-associated/project-with-company-associated-list/project-with-company-associated-list.component';


@NgModule({
  declarations: [
    ProjectCreateComponent,
    ProjectNavBarComponent,
    ProjectsManagementComponent,
    ProjectsListComponent,
    ProjectUpdateComponent,
    ProjectWithUserAssociatedComponent,
    ProjectWithUserAssociatedListComponent,
    ProjectWithCompanyAssociatedComponent,
    ProjectWithCompanyAssociatedListComponent,

  ],
  imports: [
    CommonModule,
    ProjectsManagerRoutingModule,
    ButtonModule,
    TableModule,
    ReactiveFormsModule,
    FormsModule
  ],
  providers:[DatePipe]
})

export class ProjectsManagerModule { }
