import { UserState } from './../../../../ngrx/users/user.state';
import {
  NavigateActionSuccess
} from './../../../../ngrx/users/users.actions';
import { GetAllUsersAction } from '../../../../ngrx/users/users.actions';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';
import { Router } from '@angular/router';
import { UserActionTypes } from 'src/app/ngrx/users/user.action.types';

@Component({
  selector: 'app-user-nav-bar',
  templateUrl: './user-nav-bar.component.html',
  styleUrls: ['./user-nav-bar.component.css'],
})
export class UserNavBarComponent implements OnInit{
  constructor(
    private store: Store<{ userReducerKey: UserState }>,
    private router: Router
  ) {}

  userActionTypes = UserActionTypes;
  userState!: UserState;

  ngOnInit(): void {

    this.store.subscribe((userState)=>{
      this.userState = userState.userReducerKey;
    })
  }



  onUserCreate(): void {
    this.router.navigateByUrl('/user-create');
  }

  onUsersGetAll(): any {
    this.store.dispatch(new GetAllUsersAction({}));
  }

  onGetUser_s_Projects(): any {
   this.store.dispatch(new NavigateActionSuccess({}))
  }

}
