import { MsgState } from './../../../../ngrx/msg.state';
import { Observable } from 'rxjs';
import { GetUser_S_Projects, UserActionUnion } from './../../../../ngrx/users/users.actions';
import { UserState } from './../../../../ngrx/users/user.state';
import { Component, OnInit } from '@angular/core';
import { Store } from '@ngrx/store';
import { User } from 'src/app/shared/models/user/user.model';

@Component({
  selector: 'app-user-s-projects',
  templateUrl: './user-s-projects.component.html',
  styleUrls: ['./user-s-projects.component.css'],
})
export class UserSProjectsComponent implements OnInit {
  constructor(
    private store: Store<{ userReducerKey: UserState }>,
  ) {

  }

  usersState$!: Observable<{
    currentUser: User| null,
    usersList: any,
    msgState: MsgState,
    serverMsgError: string
  }>

  msgState = MsgState;

  ngOnInit(): void {

    this.store.dispatch(new GetUser_S_Projects({}));

    this.usersState$= this.store.select("userReducerKey");
  }
}
