import { NgModule } from '@angular/core';
import { CommonModule, DatePipe } from '@angular/common';
import { ButtonModule } from "primeng/button";
import { UsersManagerRoutingModule } from './users-manager-routing.module';
import { UserCreateComponent } from './users-management/user-create/user-create.component';
import { UsersManagementComponent } from './users-management/users-management.component';
import { UserNavBarComponent } from './users-management/user-nav-bar/user-nav-bar.component';
import { TableModule } from "primeng/table";
import { UsersListComponent } from './users-management/users-list/users-list.component';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { UserUpdateComponent } from './users-management/user-update/user-update.component';
import { UserSProjectsComponent } from './users-management/user-s-projects/user-s-projects.component';



@NgModule({
  declarations: [
    UserCreateComponent,
    UserNavBarComponent,
    UsersManagementComponent,
    UsersListComponent,
    UserUpdateComponent,
    UserSProjectsComponent
  ],
  imports: [
    CommonModule,
    UsersManagerRoutingModule,
    ButtonModule,
    TableModule,
    FormsModule,
    ReactiveFormsModule
  ],

  providers:[DatePipe]
})
export class UsersManagerModule { }
